---
title: MutationObserver.takeRecords()
slug: Web/API/MutationObserver/takeRecords
tags:
  - API
  - Attribute Changes
  - Changes
  - DOM Changes
  - DOM WHATWG
  - Method
  - Mutation Observer
  - Mutation Observer API
  - MutationObserver
  - MutationObserver API
  - Observer
  - mutation
  - takeRecords
---
<div>{{APIRef("DOM WHATWG")}}</div>

<p><span class="seoSummary">The {{domxref("MutationObserver")}} method <code><strong>takeRecords()</strong></code> returns a list of all matching DOM changes that have been detected but not yet processed by the observer's callback function, leaving the mutation queue empty.</span> The most common use case for this is to immediately fetch all pending mutation records immediately prior to disconnecting the observer, so that any pending mutations can be processed when stopping down the observer.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">const <var>mutationRecords</var> = <var>mutationObserver</var>.takeRecords()
</pre>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Return_value">Return value</h3>

<p>An array {{domxref("MutationRecord")}} objects, each describing one change applied to the observed portion of the document's DOM tree.</p>

<div class="note">
<p><strong>Note:</strong> The queue of mutations which have occurred, but not been delivered to the observer's callback is left empty after calling <code>takeRecords()</code>.</p>
</div>

<h2 id="Example">Example</h2>

<p>In this example, we demonstrate how to handle any undelivered {{domxref("MutationRecord")}}s by calling <code>takeRecords()</code> just before disconnecting the observer.</p>

<pre class="brush: js; highlight:[12-18] notranslate">const targetNode = document.querySelector("#someElement");
const observerOptions = {
  childList: true,
  attributes: true
}

const observer = new MutationObserver(callback);
observer.observe(targetNode, observerOptions);

/* ...later, when it's time to stop observing... */

/* handle any still-pending mutations */

let mutations = observer.takeRecords();

observer.disconnect();

if (mutations) {
  callback(mutations);
}
</pre>

<p>The code in lines 12–17 fetches any unprocessed mutation records, then invokes the callback with the records so that they can be processed. This is done immediately prior to calling {{domxref("MutationObserver.disconnect", "disconnect()")}} to stop observing the DOM.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#dom-mutationobserver-takerecords', 'MutationObserver.takeRecords()')}}</td>
   <td>{{ Spec2('DOM WHATWG') }}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.MutationObserver.takeRecords")}}</p>
